(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('react-netlify-identity'), require('@reach/dialog'), require('@reach/visually-hidden')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'react-netlify-identity', '@reach/dialog', '@reach/visually-hidden'], factory) :
  (factory((global['react-netlify-identity-widget'] = {}),global.React,global.reactNetlifyIdentity,global.dialog,global.VisuallyHidden));
}(this, (function (exports,React,reactNetlifyIdentity,dialog,VisuallyHidden) { 'use strict';

  React = React && React.hasOwnProperty('default') ? React['default'] : React;
  VisuallyHidden = VisuallyHidden && VisuallyHidden.hasOwnProperty('default') ? VisuallyHidden['default'] : VisuallyHidden;

  const IdentityContext = React.createContext(undefined); // not necessary but recommended

  function useLoading() {
      const [isLoading, setState] = React.useState(false);
      function load(aPromise) {
          setState(true);
          return aPromise
              .then((...args) => {
              setState(false);
              return Promise.resolve(...args);
          })
              .catch((...args) => {
              setState(false);
              return Promise.reject(...args);
          });
      }
      return [isLoading, load];
  }

  // log in/sign up example
  function Login() {
      const identity = React.useContext(IdentityContext);
      if (!identity)
          throw new Error("invalid context");
      const { loginUser, signupUser } = identity;
      const formRef = React.useRef(null);
      const [msg, setMsg] = React.useState("");
      const [isLoading, load] = useLoading();
      const signup = () => {
          if (!formRef.current)
              return;
          const email = formRef.current.email.value;
          const password = formRef.current.password.value;
          const data = { signupSource: "react-netlify-identity-widget" };
          load(signupUser(email, password, data))
              .then(user => {
              console.log("Success! Signed up", user);
              // navigate("/dashboard")
          })
              .catch(err => void console.error(err) || setMsg("Error: " + err.message));
      };
      return (React.createElement("form", { ref: formRef, onSubmit: (e) => {
              e.preventDefault();
              const target = e.target;
              const email = target.email.value;
              const password = target.password.value;
              load(loginUser(email, password, true))
                  .then(user => {
                  console.log("Success! Logged in", user);
                  // navigate("/dashboard")
              })
                  .catch(err => void console.error(err) || setMsg("Error: " + err.message));
          } },
          React.createElement("div", null,
              React.createElement("label", null,
                  "Email:",
                  React.createElement("input", { type: "email", name: "email" }))),
          React.createElement("div", null,
              React.createElement("label", null,
                  "Password:",
                  React.createElement("input", { type: "password", name: "password" }))),
          React.createElement("div", null,
              isLoading && "loading...",
              React.createElement("input", { type: "submit", value: "Log in" }),
              React.createElement("button", { onClick: signup }, "Sign Up "),
              msg && React.createElement("pre", null, msg))));
  }

  function Logout() {
      const identity = React.useContext(IdentityContext);
      if (!identity)
          throw new Error("bad context");
      return React.createElement("button", { onClick: identity.logoutUser }, "You are signed in. Log Out");
  }

  // const pagesWithHeader = { login: true, signup: true }
  // const pages = {
  //   login: {
  //     login: true,
  //     button: "Log in",
  //     button_saving: "Logging in",
  //     email: true,
  //     password: true,
  //     link: "amnesia",
  //     link_text: "Forgot password?",
  //     providers: true
  //   },
  //   signup: {
  //     signup: true,
  //     button: "Sign up",
  //     button_saving: "Signing Up",
  //     name: true,
  //     email: true,
  //     password: true,
  //     providers: true
  //   },
  //   amnesia: {
  //     title: "Recover password",
  //     button: "Send recovery email",
  //     button_saving: "Sending recovery email",
  //     email: true,
  //     link: "login",
  //     link_text: "Never mind"
  //   },
  //   recovery: {
  //     title: "Recover password",
  //     button: "Update password",
  //     button_saving: "Updating password",
  //     password: true,
  //     link: "login",
  //     link_text: "Never mind"
  //   },
  //   invite: {
  //     title: "Complete your signup",
  //     button: "Sign up",
  //     button_saving: "Signing Up",
  //     password: true,
  //     providers: true
  //   },
  //   user: {
  //     title: "Logged in"
  //   }
  // }
  function LoggedOutScreen() {
      return React.createElement(Login, null);
  }
  function LoggedInScreen() {
      return React.createElement(Logout, null);
  }
  function Gate() {
      const identity = React.useContext(IdentityContext);
      const isLoggedIn = Boolean(identity && identity.user);
      return isLoggedIn ? React.createElement(LoggedInScreen, null) : React.createElement(LoggedOutScreen, null);
  }
  function Widget({ netlifyInstance }) {
      const identity = reactNetlifyIdentity.useNetlifyIdentity(netlifyInstance); // supply the url of your Netlify site instance. VERY IMPORTANT
      return (React.createElement(IdentityContext.Provider, { value: identity },
          React.createElement(Gate, null)));
  }
  // renderBody() {
  //   const { store } = this.props
  //   const page = pages[store.modal.page] || {}
  //   const pageLinkHandler = () => this.handlePage(page.link)
  //   if (!store.gotrue) {
  //     return <SiteURLForm onSiteURL={this.handleSiteURL} />
  //   }
  //   if (!store.settings) {
  //     return
  //   }
  //   if (store.user) {
  //     return <LogoutForm user={store.user} saving={store.saving} onLogout={this.handleLogout} />
  //   }
  //   if (store.modal.page === "signup" && store.settings.disable_signup) {
  //     return <Message type="signup_disabled" />
  //   }
  //   return (
  //     <div>
  //       <UserForm
  //         page={pages[store.modal.page] || {}}
  //         message={store.message}
  //         saving={store.saving}
  //         onSubmit={this.handleUser}
  //         namePlaceholder={store.namePlaceholder}
  //       />
  //       {!store.user && page.link && store.gotrue && (
  //         <button onclick={pageLinkHandler} className="btnLink forgotPasswordLink">
  //           {page.link_text}
  //         </button>
  //       )}
  //       <SiteURLForm devMode="true" onSiteURL={this.clearSiteURL} />
  //     </div>
  //   )
  // }
  // renderProviders() {
  //   const { store } = this.props
  //   if (!(store.gotrue && store.settings)) {
  //     return null
  //   }
  //   if (store.modal.page === "signup" && store.settings.disable_signup) {
  //     return null
  //   }
  //   const page = pages[store.modal.page] || {}
  //   if (!page.providers) {
  //     return null
  //   }
  //   const providers = ["Google", "GitHub", "GitLab", "BitBucket", "SAML"].filter(
  //     p => store.settings.external[p.toLowerCase()]
  //   )
  //   return providers.length ? (
  //     <Providers
  //       providers={providers}
  //       labels={store.settings.external_labels || {}}
  //       onLogin={this.handleExternalLogin}
  //     />
  //   ) : null
  // }

  function Modal({ showDialog, onCloseDialog, netlifyInstance }) {
      if (!netlifyInstance) {
          // just a safety check in case a JS user tries to skip this
          if (!validateUrl(netlifyInstance))
              throw new Error("invalid netlify instance URL: " +
                  netlifyInstance +
                  ". Please check the docs for proper usage or file an issue.");
      }
      return (React.createElement(dialog.DialogOverlay, { isOpen: showDialog },
          React.createElement(dialog.DialogContent, { style: {
                  border: "solid 5px hsla(0, 0%, 0%, 0.5)",
                  borderRadius: "10px"
              } },
              React.createElement("button", { className: "close-button", onClick: onCloseDialog },
                  React.createElement(VisuallyHidden, null, "Close"),
                  React.createElement("span", { "aria-hidden": true }, "\u00D7")),
              React.createElement("div", null,
                  "widget",
                  React.createElement(Widget, { netlifyInstance: netlifyInstance })))));
  }
  function validateUrl(value) {
      return /^(?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})))(?::\d{2,5})?(?:[/?#]\S*)?$/i.test(value);
  }

  exports.Modal = Modal;

})));
//# sourceMappingURL=reactNetlifyIdentityWidget.umd.development.js.map
